*******************************
define class sample1 as mtsbase olepublic
*******************************
	* Values for custom properties
	cTier = 'FirstTier'

	******************
	procedure GenError1
	******************
	lparameters tcErrors
	this.cAction = 'GenError1'

	* this shows how a syntax error will show up in the XML
	stupidsyntaxerror

	* errors in this object are logged to FirstTier.xml
	this.logErrors()
	tcErrors = this.cXML
	this.cXML = ''
	******************
	endproc  && GenError1
	******************


	******************
	procedure GenError2
	******************
	lparameters tcErrors
	this.cAction = 'GenError2'

	* here's a different kind of error; a wrong method name call
	this.MethodWeForgetAbout()

	this.logErrors()
	tcErrors = this.cXML
	this.cXML = ''
	******************
	endproc  && GenError2
	******************


	******************
	procedure GenError3
	******************
	lparameters tcErrors
	this.cAction = 'GenError3'

	* UI stuff is not allowed in COM object.  This shows the effect of sys(2335, 0) in Init()
	wait window 'Cannot do this in a COM object'

	this.logErrors()
	tcErrors = this.cXML
	this.cXML = ''
	******************
	endproc  && GenError3
	******************


	******************
	procedure GenError4
	******************
	lparameters tcErrors
	this.cAction = 'GenError4'

	* this shows how the calling chain is shown in the XML
	this.FactoredCode()
	* and then we get another error here
	sqrt('Another Error')

	this.logErrors()
	tcErrors = this.cXML
	this.cXML = ''
	******************
	endproc  && GenError4
	******************


	******************
	hidden procedure FactoredCode
	******************

	this.uNkOwNpRoPeRtY = 'This is an error too'

	* methods that are not COM methods do not log the errors

	******************
	endproc  && FactoredCode
	******************


	******************
	procedure GenError5
	******************
	lparameters tcErrors, tlUseVFPObj

	this.cAction = 'GenError5'

	local lcErrors

	* now we create an object from another tier
	if tlUseVFPOBJ
		loSecondTier = newobject('Sample2', 'samples2.prg')
	else
		loSecondTier = createobject('mtserrors2.Sample2')
	endif

	* but before we call any methods we get an error here in this object
	this.HaveErrorInFirstTier()

	lcErrors = ''
	* and this method will cause an error in the second object
	* note that the xml files are different because of different tiers
	loSecondTier.GenError99(@lcErrors)

	* after we call aother COM object we combine errors from it with
	* errors we may already have in this object all into this.cXML.  Then
	* we can return the whole thing back to the client who called us.
	this.ConcatenateXMLs(this.cXML, lcErrors)

	this.logErrors()
	tcErrors = this.cXML
	this.cXML = ''
	******************
	endproc  && GenError5
	******************
*******************************
enddefine  && class sample1
*******************************

